uses crt,grafx2,gx_glob,pnglib,stream32;
var
  a : array [1..4] of double;
  b : array [1..4] of double;
  c : array [1..4] of double;
  d : array [1..4] of double;
  e : array [1..4] of double;
  f : array [1..4] of double;
  p : array [1..4] of double;
  k                 : integer;
  zmax,smax         : integer;
  x1,y1,xwide,ywide : integer;
  xneu,yneu,ran,x,y : double;
  l                 : longint;
  screen            : tgxscreen;
  gx2               : timage;
  s                 : tfilestream32;

procedure initfern;
begin
  x := 0;
  y := 0;
  randomize;
  a[1] :=  0   ;
  a[2] :=  0.2 ;
  a[3] := -0.15;
  a[4] :=  0.85;
  b[1] :=  0   ;
  b[2] := -0.26;
  b[3] :=  0.28;
  b[4] :=  0.04;
  c[1] :=  0   ;
  c[2] :=  0.23;
  c[3] :=  0.26;
  c[4] := -0.04;
  d[1] :=  0.16;
  d[2] :=  0.22;
  d[3] :=  0.24;
  d[4] :=  0.85;
  e[1] :=  0   ;
  e[2] :=  0   ;
  e[3] :=  0   ;
  e[4] :=  0   ;
  f[1] :=  0   ;
  f[2] :=  1.6 ;
  f[3] :=  0.44;
  f[4] :=  1.6 ;
  p[1] :=  10  ;
  p[2] :=  80  ;
  p[3] :=  150 ;
  p[4] :=  1000;
end;

begin
  if not screen.init(640,480,clhi,mdauto) then
    writeln(gxerror,'Error while initializing video mode');

  s.init('images\gx2sm2.png',stopenread);
  check4fail(loadpng(s,gx2,screen.mode.bpp,ldalpha));

  initfern;

  xwide := screen.maxx div 2;
  ywide := screen.maxy - screen.maxy div 16;
  smax  := screen.maxx div 8;
  zmax  := screen.maxy div 11;

  for l := 0 to screen.maxy do
  begin
    screen.hline(0,l,screen.maxx+1,screen.rgb(0,round(l/screen.maxy*255),0));
  end;

  for l := 0 to screen.maxy * 600 do
  begin
    ran := random(1000);
    if (ran <= p[4]) then k := 4;
    if (ran <= p[3]) then k := 3;
    if (ran <= p[2]) then k := 2;
    if (ran <= p[1]) then k := 1;
    xneu := (a[k]*x) + (b[k]*y) + e[k];
    yneu := (c[k]*x) + (d[k]*y) + f[k];
    x    := xneu;
    y    := yneu;
    x1   := round((x * smax) + xwide);
    y1   := round(ywide - (y * zmax));
    screen.addpixel(x1,y1,screen.rgb(0,8,0));
  end;

  screen.draw(0,screen.maxy-gx2.sizey,gx2,drdefault);

  readkey;
  closeimage(gx2);
  screen.close;
end.

